package cn.zhangdeman.filter;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import jakarta.servlet.http.HttpServletResponse;
import lombok.Getter;
import lombok.Setter;

import java.util.HashMap;
import java.util.Map;

// 响应数据
@Getter
@Setter
@JsonIgnoreProperties(ignoreUnknown = true) // 忽略未知属性字段
public class Response {
    @JsonProperty(RecordField.RESPONSE_CODE)
    private String code; // 响应业务状态码
    @JsonProperty(RecordField.RESPONSE_MESSAGE)
    private String message; // 响应消息
    @JsonProperty(RecordField.RESPONSE_DATA)
    private Object data; // 响应数据
    @JsonProperty(RecordField.RESPONSE_ERROR_DETAIL)
    private Object errorDetail; // 异常详情
    @JsonProperty(RecordField.RESPONSE_HTTP_CODE)
    private Integer httpCode = 200; // 响应http状态码
    @JsonProperty(RecordField.RESPONSE_HEADER)
    private Map<String, String> header; // 响应头
    @JsonProperty(RecordField.RESPONSE_COOKIE)
    private Map<String, String> cookie; // 响应cookie
    @JsonIgnore
    private HttpServletResponse httpServletResponse; // 响应实例

    public void addHeader(String key, String value) {
        if (null == this.header) {
            this.header = new HashMap<>();
        }
        this.header.put(key, value);
    }

    public void addCookie(String key, String value) {
        if (null == this.cookie) {
            this.cookie = new HashMap<>();
        }
        this.cookie.put(key, value);
    }
}
